    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * -------------------------------
    028     * CategoryItemLabelGenerator.java
    029     * -------------------------------
    030     * (C) Copyright 2001-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 13-Dec-2001 : Version 1 (DG);
    038     * 16-Jan-2002 : Completed Javadocs (DG);
    039     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    040     * 24-Oct-2002 : Method now specifies category index (DG);
    041     * 05-Nov-2002 : Replaced reference to CategoryDataset with TableDataset (DG);
    042     * 21-Jan-2003 : TableDataset merged with CategoryDataset (DG);
    043     * 10-Apr-2003 : Changed CategoryDataset --> KeyedValues2DDataset (DG);
    044     * 01-May-2003 : Added generateValueLabel() method (with a plan to renaming
    045     *               this interface to reflect its more general use) (DG);
    046     * 09-Jun-2003 : Renamed CategoryToolTipGenerator
    047     *               --> CategoryItemLabelGenerator (DG);
    048     * 13-Aug-2003 : Added clone() method (DG);
    049     * 12-Feb-2004 : Removed clone() method (DG);
    050     * 15-Apr-2004 : Moved generateToolTip() method into CategoryToolTipGenerator
    051     *               interface (DG);
    052     * 11-May-2004 : Renamed CategoryItemLabelGenerator
    053     *               --> CategoryLabelGenerator (DG);
    054     * 31-Jan-2005 : Added generateRowLabel() and generateColumnLabel()
    055     *               methods (DG);
    056     * 20-Apr-2005 : Reverted name change of 11-May-2004 (DG);
    057     *
    058     */
    059
    060    package org.jfree.chart.labels;
    061
    062    import org.jfree.data.category.CategoryDataset;
    063
    064    /**
    065     * A <i>category item label generator</i> is an object that can be assigned to a
    066     * {@link org.jfree.chart.renderer.category.CategoryItemRenderer} and that
    067     * assumes responsibility for creating text items to be used as labels for the
    068     * items in a {@link org.jfree.chart.plot.CategoryPlot}.
    069     * <p>
    070     * To assist with cloning charts, classes that implement this interface should
    071     * also implement the {@link org.jfree.util.PublicCloneable} interface.
    072     */
    073    public interface CategoryItemLabelGenerator {
    074
    075        /**
    076         * Generates a label for the specified row.
    077         *
    078         * @param dataset  the dataset (<code>null</code> not permitted).
    079         * @param row  the row index (zero-based).
    080         *
    081         * @return The label.
    082         */
    083        public String generateRowLabel(CategoryDataset dataset, int row);
    084
    085        /**
    086         * Generates a label for the specified row.
    087         *
    088         * @param dataset  the dataset (<code>null</code> not permitted).
    089         * @param column  the column index (zero-based).
    090         *
    091         * @return The label.
    092         */
    093        public String generateColumnLabel(CategoryDataset dataset, int column);
    094
    095        /**
    096         * Generates a label for the specified item. The label is typically a
    097         * formatted version of the data value, but any text can be used.
    098         *
    099         * @param dataset  the dataset (<code>null</code> not permitted).
    100         * @param row  the row index (zero-based).
    101         * @param column  the column index (zero-based).
    102         *
    103         * @return The label (possibly <code>null</code>).
    104         */
    105        public String generateLabel(CategoryDataset dataset, int row, int column);
    106
    107    }